\section{Software Architecture}
Typically the architect does design the architecture of the system. This is a very important step and the architect is accountable for the design of the system. The developers in the agile team do work with the architecture to program the software system.

\begin{figure}[hbt]
  \center
  \includegraphics[width=0.76\textwidth]{archinteraction}
  \caption{Interction of Entities in an Architecture}
\end{figure}

\subsection{Software Architecture}
\begin{quote}
	«The fundamental organization of a system embodied in its components, their relationships to each other and to the environment, and the principles guiding its design and evolutions.» - IEEE-1471
\end{quote}

\begin{quote}
	«A framework for change.» - Tom DeMarco
\end{quote}

There are some similarities between the architects and the software architects. For example we try to separate the system into components to better understand the architecture. Additionally we build relationships between the components. The architecture should allow change or the evolution of the architecture.

\paragraph{Benefits of Architecture} \hfill
\begin{itemize}
	\itemsep -0.2em
	\item Provides an overview
	\item Eases the understanding 
	\item Promotes communication between the involved members
	\item Provides a framework for functional requirements
	\item Increases the quality of the product
	\item Reduces the risks
	\item Ensure the longevity of the software
\end{itemize}

\subsubsection{Architecture vs. Design}
Architecture focuses on the big picture, the components, boundaries and interfaces. The design addresses smaller challenges within these components. As an analogy the process of building a house could be taken. The architecture contains the fundamental plan describing how to build it safe and durable. Within this skeleton, rooms may be designed individually with minor impact safety. Although, you might want to apply the design consistently to reduce cost (design patterns).

\subsubsection{Inputs for the Architecture}
There are different inputs taken into the process of creating a software architecture. These are mostly the functional and non-functional requirements.

\begin{minipage}{0.5\textwidth}
	\textbf{Functional}	
	\begin{itemize}
		\item Use Cases, User Stories, Domain Model, …
		\item Mostly gathered by a Requirement Engineer
		\item Minor impact on target architecture
		\item Source for project glossary (domain terms) 
	\end{itemize}	
\end{minipage}  
\begin{minipage}{0.5\textwidth}
	\textbf{Non-functoinal}
	\begin{itemize}
		\item Quality Scenarios, Quality Tree, …
		\item Mostly gathered by a Software Architect
		\item Major impact on target architecture
		\item Conflicts are possible, prioritization is needed
	\end{itemize}
\end{minipage}    

\subsubsection{Context}
Our system has to interact with old and existing software. All these systems has to be considered into the planning process for an architecture. This step has a huge potential for error since a lot of communication. between people is required in order to get an understanding of the other systems.

\begin{figure}[hbt]
  \center
  \includegraphics[width=0.7\textwidth]{context}
  \caption{Context of a System}
\end{figure}

\subsubsection{Components}
The main task is to draw lines in the system itself. There are two fundamental rules to draw lines in a system: separate by similarity and separate domain from technology.

\begin{minipage}{0.5\textwidth}
	\textbf{Separate by similarity}	
	\begin{itemize}
		\item Similar in functionality
		\item Similar in technological implementation
	\end{itemize}
	\center	
	\includegraphics[width=0.75\textwidth]{similarity}
\end{minipage}  
\begin{minipage}{0.5\textwidth}
	\textbf{Separate domain from technology}
	\begin{itemize}
		\item Domain is stable and long living
		\item Technology is volatile and short living
	\end{itemize}
	\center
	\includegraphics[width=0.75\textwidth]{technology}
\end{minipage} 

\subsubsection{ACT - Adequacy, Consistency, Timeless}
%todo add defintion

	
\subsection{Architects}

\begin{enumerate}
	\item -
	\item -
	\item -
	\item -
	\item -
\end{enumerate}

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{architectrepsonsibilities}
  \caption{The Responsibilities of a Software Architect}
\end{figure}


\subsubsection{The Role}
Typically the architect of a software system is designed by an experienced software engineer. There are different approaches to fill the role of a software architect. Most of the time one architect is not enough for the system and there a model as architecture agents makes perfect sense. 

\begin{figure}[hbt]
  \center
  \includegraphics[width=0.75\textwidth]{architect}
  \caption{Software Architect}
\end{figure}

\paragraph{Scaling the Role} \hfill \\
In a big software project are multiple teams developing a part of the software and therefore there is an architect for every team of the project teams. These architects must exchange with each other in order to make sure the teams do develop the system in a good way.

\paragraph{Communicatoin} \hfill \\
Architects must communicate with many different stakeholders, like User - Requirements, RE - requirements, UI/UX - Requirements, DEV - components, interfaces, concepts, PO - processes, backlog management, PL - budget, risks, constraints.

The best architects are good communicators!

\subsubsection{Design}

\begin{minipage}{0.5\textwidth}
	\textbf{Top-Down Design}
	\begin{itemize}
		\item Provides an overview
		\item Start with the big, work towards the small
		\item Perfect for documentation and communication
	\end{itemize}
\end{minipage}
\begin{minipage}{0.5\textwidth}
	\textbf{Bottom-Up Design}
	\begin{itemize}
		\item Addresses technical risks
		\item Solve a single problem, generalise afterwards
		\item Might lead to insufficient consistency
	\end{itemize}
\end{minipage}

\subsubsection{Anti-Patterns}
There are a lot of anti-patterns which a software architect should not follow in order to produce a good architecture.


\subsection{Documentation}
\textbf{Things to consider:} focus on high-level topics, prefer diagrams over text, generate diagrams from code, use a known template, use a version-able format, use a format that allows collaboration, perform reviews.

There are a lot of existing templates which should be used to create the documentation for the project. There are similarities between the templates: high-level first, details later (or never), building blocks that must be tailored, different views, like static, dynamic or deployment.

\begin{figure}[hbt]
  \center
  \includegraphics[width=0.75\textwidth]{arc42}
  \caption{Template example arc42}
\end{figure}

\subsection{Architectural Patterns}
%todo add content of week 05


